<?php
/**
 * Garden Farm functions and definitions
 *
 * @package Garden Farm
 */

/**
 * Set the content width based on the theme's design and stylesheet.
 */

if ( ! function_exists( 'garden_farm_setup' ) ) :
/**
 * Sets up theme defaults and registers support for various WordPress features.
 *
 * Note that this function is hooked into the after_setup_theme hook, which runs
 * before the init hook. The init hook is too late for some features, such as indicating
 * support post thumbnails.
 */
function garden_farm_setup() {
	global $content_width;
	if ( ! isset( $content_width ) )
		$content_width = 680;
	
	load_theme_textdomain( 'garden-farm', get_template_directory() . '/languages' );
	add_theme_support( 'automatic-feed-links' );
	add_theme_support( "responsive-embeds" );
	add_theme_support( 'align-wide' );
	add_theme_support( 'woocommerce' );
	add_theme_support( 'post-thumbnails' );
	add_theme_support( 'title-tag' );
	add_theme_support( 'wp-block-styles');
	add_theme_support( 'custom-header', array(
		'default-text-color' => false,
		'header-text' => false,
	) );
	add_theme_support( 'custom-logo', array(
		'height'      => 80,
		'width'       => 80,
		'flex-height' => true,
	) );
	register_nav_menus( array(
		'primary' => __( 'Primary Menu', 'garden-farm' ),
	) );
	add_theme_support( 'custom-background', array(
		'default-color' => 'ffffff'
	) );
	add_theme_support( 'html5', array(
		'search-form',
		'comment-form',
		'comment-list',
		'gallery',
		'caption',
	) );

	/*
	 * Enable support for Post Formats.
	 */
	add_theme_support( 'post-formats', array('image','video','gallery','audio',) );

	add_editor_style( 'editor-style.css' );

	// Theme Activation Notice
	global $pagenow;

	if (
		is_admin()
		&&
		('themes.php' == $pagenow)
		// &&
		// isset( $_GET['activated'] )
	) {
		add_action('admin_notices', 'garden_farm_deprecated_hook_admin_notice');
	}
}
endif; // garden_farm_setup
add_action( 'after_setup_theme', 'garden_farm_setup' );

function garden_farm_the_breadcrumb() {
    echo '<div class="breadcrumb my-3">';

    if (!is_home()) {
        echo '<a class="home-main align-self-center" href="' . esc_url(home_url()) . '">';
        bloginfo('name');
        echo "</a>";

        if (is_category() || is_single()) {
            the_category(' ');
            if (is_single()) {
                echo '<span class="current-breadcrumb mx-3">' . esc_html(get_the_title()) . '</span>';
            }
        } elseif (is_page()) {
            echo '<span class="current-breadcrumb mx-3">' . esc_html(get_the_title()) . '</span>';
        }
    }

    echo '</div>';
}

function garden_farm_widgets_init() {
	register_sidebar( array(
		'name'          => __( 'Blog Sidebar', 'garden-farm' ),
		'description'   => __( 'Appears on blog page sidebar', 'garden-farm' ),
		'id'            => 'sidebar-1',
		'before_widget' => '<aside id="%1$s" class="widget %2$s">',
		'after_widget'  => '</aside>',
		'before_title'  => '<h3 class="widget-title">',
		'after_title'   => '</h3>',
	) );

	register_sidebar( array(
		'name'          => __( 'Page Sidebar', 'garden-farm' ),
		'id'            => 'sidebar-2',
		'description'   => __( 'Add widgets here to appear in your sidebar on pages.', 'garden-farm' ),
		'before_widget' => '<section id="%1$s" class="widget %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<h3 class="widget-title">',
		'after_title'   => '</h3>',
	) );

	register_sidebar( array(
		'name'          => __( 'Sidebar 3', 'garden-farm' ),
		'id'            => 'sidebar-3',
		'description'   => __( 'Add widgets here to appear in your sidebar on blog posts and archive pages.', 'garden-farm' ),
		'before_widget' => '<section id="%1$s" class="widget %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<h3 class="widget-title">',
		'after_title'   => '</h3>',
	) );

	register_sidebar(array(
        'name'          => __('Shop Sidebar', 'garden-farm'),
        'description'   => __('Sidebar for WooCommerce shop pages', 'garden-farm'),
		'id'            => 'woocommerce_sidebar',
        'before_widget' => '<aside id="%1$s" class="widget %2$s">',
        'after_widget'  => '</aside>',
        'before_title'  => '<h3 class="widget-title">',
        'after_title'   => '</h3>',
    ));
	register_sidebar(array(
        'name'          => __('Single Product Sidebar', 'garden-farm'),
        'description'   => __('Sidebar for single product pages', 'garden-farm'),
		'id'            => 'woocommerce-single-sidebar',
        'before_widget' => '<aside id="%1$s" class="widget %2$s">',
        'after_widget'  => '</aside>',
        'before_title'  => '<h3 class="widget-title">',
        'after_title'   => '</h3>',
    ));		
	
	$garden_farm_widget_areas = get_theme_mod('garden_farm_footer_widget_areas', '4');
	for ($garden_farm_i=1; $garden_farm_i <= 4; $garden_farm_i++) {
		register_sidebar( array(
			'name'          => __( 'Footer Widget ', 'garden-farm' ) . $garden_farm_i,
			'id'            => 'footer-' . $garden_farm_i,
			'description'   => '',
			'before_widget' => '<aside id="%1$s" class="ftr-4-box widget-column-4 %2$s">',
			'after_widget'  => '</aside>',
			'before_title'  => '<h3 class="widget-title">',
			'after_title'   => '</h3>',
		) );
	}

}
add_action( 'widgets_init', 'garden_farm_widgets_init' );

// Change number of products per row to 4
add_filter('loop_shop_columns', 'garden_farm_loop_columns');
if (!function_exists('garden_farm_loop_columns')) {
    function garden_farm_loop_columns() {
        $garden_farm_colm = get_theme_mod('garden_farm_products_per_row', 4); // Default to 4 if not set
        return $garden_farm_colm;
    }
}

// Use the customizer setting to set the number of products per page
function garden_farm_products_per_page($garden_farm_cols) {
    $garden_farm_cols = get_theme_mod('garden_farm_products_per_page', 9); // Default to 9 if not set
    return $garden_farm_cols;
}
add_filter('loop_shop_per_page', 'garden_farm_products_per_page', 9);

function garden_farm_scripts() {
	
	wp_enqueue_style( 'bootstrap-css', esc_url(get_template_directory_uri())."/css/bootstrap.css" );
	wp_enqueue_style('garden-farm-style', get_stylesheet_uri(), array() );
		wp_style_add_data('garden-farm-style', 'rtl', 'replace');

	require get_parent_theme_file_path( '/inc/color-scheme/custom-color-control.php' );
	wp_add_inline_style( 'garden-farm-style',$garden_farm_color_scheme_css );
	wp_enqueue_style( 'owl.carousel-css', esc_url(get_template_directory_uri())."/css/owl.carousel.css" );
	wp_enqueue_style( 'garden-farm-default', esc_url(get_template_directory_uri())."/css/default.css" );	
	wp_enqueue_style( 'garden-farm-style', get_stylesheet_uri() );
	wp_enqueue_script( 'owl.carousel-js', esc_url(get_template_directory_uri()). '/js/owl.carousel.js', array('jquery') );
	wp_enqueue_script( 'bootstrap-js', esc_url(get_template_directory_uri()). '/js/bootstrap.js', array('jquery') );
	wp_enqueue_script( 'garden-farm-theme', esc_url(get_template_directory_uri()) . '/js/theme.js' );
	wp_enqueue_style( 'font-awesome-css', esc_url(get_template_directory_uri())."/css/fontawesome-all.css" );
	wp_enqueue_style( 'garden-farm-block-style', esc_url( get_template_directory_uri() ).'/css/blocks.css' );	
	/*--------------------------- Animations -------------------*/
    if ( get_theme_mod( 'garden_farm_animation_enabled', true ) ) {
		wp_enqueue_script( 'wow-jquery', get_template_directory_uri() . '/js/wow.js', array('jquery'),'' ,true );
        wp_enqueue_style( 'animate-style', get_template_directory_uri().'/css/animate.css' );
    }

	if ( is_singular() && comments_open() && get_option( 'thread_comments' ) ) {
		wp_enqueue_script( 'comment-reply' );
	}

	// font-family
	$garden_farm_headings_font = esc_html(get_theme_mod('garden_farm_headings_fonts'));
    $garden_farm_body_font = esc_html(get_theme_mod('garden_farm_body_fonts'));

    if ($garden_farm_headings_font) {
        wp_enqueue_style('garden-farm-headings-fonts', 'https://fonts.googleapis.com/css?family=' . urlencode($garden_farm_headings_font));
    } else {
        wp_enqueue_style('Averia Sans Libre', 'https://fonts.googleapis.com/css2?family=Averia+Sans+Libre:ital,wght@0,300;0,400;0,700;1,300;1,400;1,700');
    }

    if ($garden_farm_body_font) {
        wp_enqueue_style('garden-farm-body-fonts', 'https://fonts.googleapis.com/css?family=' . urlencode($garden_farm_body_font));
    } else {
        wp_enqueue_style('Mulish', 'https://fonts.googleapis.com/css2?family=Mulish:ital,wght@0,200..1000;1,200..1000');
    }

}
add_action( 'wp_enqueue_scripts', 'garden_farm_scripts' );

/**
 * Implement the Custom Header feature.
 */
require get_template_directory() . '/inc/custom-header.php';

/**
 * Custom template tags for this theme.
 */
require get_template_directory() . '/inc/template-tags.php';

/**
 * Customizer additions.
 */
require get_template_directory() . '/inc/customizer.php';

/**
 * Sanitization Callbacks.
 */
require get_template_directory() . '/inc/sanitization-callbacks.php';

/**
 * Webfont-Loader.
 */
require get_template_directory() . '/inc/wptt-webfont-loader.php';

/**
 * Customizer additions.
 */
require get_template_directory() . '/inc/upgrade-to-pro.php';

/**
 * Google Fonts
 */
require get_template_directory() . '/inc/gfonts.php';

/**
 * select .
 */
require get_template_directory() . '/inc/select/category-dropdown-custom-control.php';

/**
 * Load TGM.
 */
require get_template_directory() . '/inc/tgm/tgm.php';

/**
 * Theme Info Page.
 */
require get_template_directory() . '/inc/addon.php';

function garden_farm_setup_theme() {
	if ( ! defined( 'GARDEN_FARM_PRO_NAME' ) ) {
		define( 'GARDEN_FARM_PRO_NAME', __( 'About Garden Farm', 'garden-farm' ));
	}
	if ( ! defined( 'GARDEN_FARM_PREMIUM_PAGE' ) ) {
	define('GARDEN_FARM_PREMIUM_PAGE',__('https://www.theclassictemplates.com/products/farm-wordpress-theme','garden-farm'));
	}
	if ( ! defined( 'GARDEN_FARM_THEME_PAGE' ) ) {
		define('GARDEN_FARM_THEME_PAGE',__('https://www.theclassictemplates.com/collections/best-wordpress-templates','garden-farm'));
	}
	if ( ! defined( 'GARDEN_FARM_SUPPORT' ) ) {
	define('GARDEN_FARM_SUPPORT',__('https://wordpress.org/support/theme/garden-farm/','garden-farm'));
	}
	if ( ! defined( 'GARDEN_FARM_REVIEW' ) ) {
	define('GARDEN_FARM_REVIEW',__('https://wordpress.org/support/theme/garden-farm/reviews/','garden-farm'));
	}
	if ( ! defined( 'GARDEN_FARM_PRO_DEMO' ) ) {
	define('GARDEN_FARM_PRO_DEMO',__('https://live.theclassictemplates.com/garden-farm-pro/','garden-farm'));
	}
	if ( ! defined( 'GARDEN_FARM_THEME_DOCUMENTATION' ) ) {
	define('GARDEN_FARM_THEME_DOCUMENTATION',__('https://live.theclassictemplates.com/demo/docs/garden-farm-free/','garden-farm'));
	}
	if ( ! defined( 'GARDEN_FARM_BUNDLE_PAGE' ) ) {
		define('GARDEN_FARM_BUNDLE_PAGE',__('https://www.theclassictemplates.com/products/wordpress-theme-bundle','garden-farm'));
	}
}
add_action( 'after_setup_theme', 'garden_farm_setup_theme' );

/* Starter Content */
	add_theme_support( 'starter-content', array(
		'widgets' => array(
			'footer-1' => array(
				'categories',
			),
			'footer-2' => array(
				'archives',
			),
			'footer-3' => array(
				'meta',
			),
			'footer-4' => array(
				'search',
			),
		),
    ));
    
// logo
if ( ! function_exists( 'garden_farm_the_custom_logo' ) ) :
/**
 * Displays the optional custom logo.
 *
 * Does nothing if the custom logo is not available.
 *
 */
function garden_farm_the_custom_logo() {
	if ( function_exists( 'the_custom_logo' ) ) {
		the_custom_logo();
	}
}
endif;

/* Activation Notice */
function garden_farm_deprecated_hook_admin_notice() {
	 $garden_farm_theme = wp_get_theme();
	$garden_farm_meta = get_option( 'garden_farm_admin_notice' );

	if (!$garden_farm_meta) {
    ?>
        <div id="garden-farm-welcome-notice" class="getstrat updated notice notice-success welcome-notice is-dismissible notice-get-started-class">
            <div class="admin-image">
                <img src="<?php echo esc_url(get_stylesheet_directory_uri()) .'/screenshot.png'; ?>" />
            </div>
            <div class="admin-content" >
                <h1><?php 
				/* translators: 1: Theme name, 2: Theme version. */
				printf( esc_html__( 'Welcome to %1$s %2$s', 'garden-farm' ), esc_html($garden_farm_theme->get( 'Name' )), esc_html($garden_farm_theme->get( 'Version' ))); ?>
                </h1>
                <p><?php _e('Get Started With Theme By Clicking On Getting Started.', 'garden-farm'); ?></p>
                <div style="display: grid;">
                    <a class="admin-notice-btn button button-hero upgrade-pro" target="_blank" href="<?php echo esc_url( GARDEN_FARM_PREMIUM_PAGE ); ?>"><?php esc_html_e('Upgrade Pro', 'garden-farm') ?><i class="dashicons dashicons-cart"></i></a>
                    <a class="admin-notice-btn button button-hero" href="<?php echo esc_url( admin_url( 'themes.php?page=garden-farm' )); ?>"><?php esc_html_e( 'Get started', 'garden-farm' ) ?><i class="dashicons dashicons-backup"></i></a>
                    <a class="admin-notice-btn button button-hero" target="_blank" href="<?php echo esc_url( GARDEN_FARM_THEME_DOCUMENTATION ); ?>"><?php esc_html_e('Free Doc', 'garden-farm') ?><i class="dashicons dashicons-visibility"></i></a>
                    <a  class="admin-notice-btn button button-hero" target="_blank" href="<?php echo esc_url( GARDEN_FARM_PRO_DEMO ); ?>"><?php esc_html_e('View Demo', 'garden-farm') ?><i class="dashicons dashicons-awards"></i></a>
                </div>
            </div>
			<div class="admin-bundle-image">
				<a href="<?php echo esc_url( GARDEN_FARM_BUNDLE_PAGE ); ?>" target="_blank"><img src="<?php echo esc_url(get_stylesheet_directory_uri()) .'/images/image_1.webp'; ?>" /></a>
			</div>
        </div>
	<?php
    }
}
// Admin notice code START
function garden_farm_dismissed_notice() {
	update_option( 'garden_farm_admin_notice', true );
}
add_action( 'wp_ajax_garden_farm_dismissed_notice', 'garden_farm_dismissed_notice' );


//After Switch theme function
add_action('after_switch_theme', 'garden_farm_getstart_setup_options');
function garden_farm_getstart_setup_options () {
    update_option('garden_farm_admin_notice', false );
}
// Admin notice code END